#include "denkou.h"

/**
 *   bZ[WROMɏ
 */
void write_rom(dcont_t *dcont)
{
  int size;                              /* rome, kbitP */
  int max_line,pass,nol,c;
  char **pp;
  
  size = rom_check(dcont);               /* rom̑݁AeʂȂǂ`FbN */
  max_line = (size * 128 - 256) / 2;

  for(pass=0;pass<2;pass++){
    dcont->no_out = pass==0 ?  1 : 0;
    dk_open(dcont);
    for(pp=dcont->args; *pp!=NULL; pp++){
      FILE *ifp = fopen(*pp,"r");
      if(ifp == NULL) fprintf(stderr,"file \"%s\" not found.\n",*pp);
      else {
	dcont->char0 = 0;
	while((c = getc(ifp))!=EOF){
	  dk_putc(dcont,c);
	  if(f_v){
	    if(pass == 0)
	      fprintf(stderr,"\rpass%d %6d lines found",pass+1,dcont->nol);
	    else
	      fprintf(stderr,"\rpass%d %6d/%6d %3d%% done",pass+1,
		      dcont->nol,nol, (int)(100.0*dcont->nol/nol+0.5));
	  }
	}
	fclose(ifp);
      }
    }
    dk_close(dcont);
    if(f_v) fprintf(stderr,"\n");

    if(pass == 0){
      nol = dcont->nol;
      if(nol > max_line)
	nabort("Too long text (%d lines), capacity is %d lines\n",nol,max_line);
      if(nol == 0)
	nabort("No data found.\n");
    }
  }
  if(f_v) fprintf(stderr,"write_rom complete\n");
}


int rom_check(dcont_t *dcont)
{
  char *res;
  int exist, size;
  sio_t *scont = &dcont->scont;
  
  sio_cmd(scont,"sc_clear");
  res = sio_cmd(scont,"rom_check");
  if(sscanf(res,"D exist:%d",&exist)<1)
    nabort("Bad rom_chek response:%s\n",res);
  if(!exist)
    nabort("No eeprom found on H8 board.\n");
    
  if(sscanf(res,"D exist:%*d size:%d",&size)<1)
    nabort("Bad rom_chek size response:%s\n",res);
  fprintf(stderr,"%d Kbit eeprom found.\n",size);
  return size;
}

