#!/usr/bin/perl

my $cmd_p = 0;

if($ARGV[0] =~ /^-/){
  $_ = shift;
  $cmd_p = 1 if( /^-p/);
}


$_ = <>;
unless(/^(.*\"Ver.\s*)(\d+)\.(\d+)-(\d+)(.*)(\")/ ){
    die "Bad Line:$_";
}

if($cmd_p){
  print "$2.$3\n";
  exit;
}

my (@wstr) = ("Sun","Mon","Tue","Wed","Thr","Fri","Sat");
my ($sec,$min,$hour,$mday,$mon,$year,$wday) = localtime;

printf "%s%s.%s-%02d %d/%02d/%02d(%s)\";\n",
    $1,$2,$3,$4+1,$year+1900,$mon+1,$mday,$wstr[$wday],$5;

printf "/* %s%s.%s-%02d%s */\n",$1,$2,$3,$4,$5;
while (<>) {
    s/\s*$//;
    print $_,"\n";
}
